    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * LineNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                           Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 27-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Added hashCode() implementation (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.Shape;
    050    import java.awt.geom.Line2D;
    051    import java.awt.geom.Point2D;
    052    import java.awt.geom.Rectangle2D;
    053    import java.io.Serializable;
    054
    055    /**
    056     * A needle that is represented by a line.
    057     */
    058    public class LineNeedle extends MeterNeedle
    059                            implements Cloneable, Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = 6215321387896748945L;
    063
    064        /**
    065         * Draws the needle.
    066         *
    067         * @param g2  the graphics device.
    068         * @param plotArea  the plot area.
    069         * @param rotate  the rotation point.
    070         * @param angle  the angle.
    071         */
    072        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    073                                  Point2D rotate, double angle) {
    074
    075            Line2D shape = new Line2D.Double();
    076
    077            double x = plotArea.getMinX() + (plotArea.getWidth() / 2);
    078            shape.setLine(x, plotArea.getMinY(), x, plotArea.getMaxY());
    079
    080            Shape s = shape;
    081
    082            if ((rotate != null) && (angle != 0)) {
    083                /// we have rotation
    084                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    085                s = getTransform().createTransformedShape(s);
    086            }
    087
    088            defaultDisplay(g2, s);
    089
    090        }
    091
    092        /**
    093         * Tests another object for equality with this object.
    094         *
    095         * @param obj  the object to test (<code>null</code> permitted).
    096         *
    097         * @return A boolean.
    098         */
    099        public boolean equals(Object obj) {
    100            if (obj == this) {
    101                return true;
    102            }
    103            if (!(obj instanceof LineNeedle)) {
    104                return false;
    105            }
    106            return super.equals(obj);
    107        }
    108
    109        /**
    110         * Returns a hash code for this instance.
    111         *
    112         * @return A hash code.
    113         */
    114        public int hashCode() {
    115            return super.hashCode();
    116        }
    117
    118        /**
    119         * Returns a clone of this needle.
    120         *
    121         * @return A clone.
    122         *
    123         * @throws CloneNotSupportedException if the <code>LineNeedle</code>
    124         *     cannot be cloned (in theory, this should not happen).
    125         */
    126        public Object clone() throws CloneNotSupportedException {
    127            return super.clone();
    128        }
    129
    130    }
    131